package cn.iocoder.yudao.module.system.service.attendance;

import com.alibaba.excel.metadata.Head;
import com.alibaba.excel.metadata.data.WriteCellData;
import com.alibaba.excel.write.handler.CellWriteHandler;
import com.alibaba.excel.write.metadata.holder.WriteSheetHolder;
import com.alibaba.excel.write.metadata.holder.WriteTableHolder;
import com.alibaba.excel.write.metadata.style.WriteCellStyle;
import com.alibaba.excel.write.metadata.style.WriteFont;
import org.apache.poi.ss.usermodel.*;

import java.util.List;

public class CustomCellStyleHandler implements CellWriteHandler {

    @Override
    public void afterCellDispose(
            WriteSheetHolder writeSheetHolder,
            WriteTableHolder writeTableHolder,
            List<WriteCellData<?>> cellDataList,
            Cell cell,
            Head head,
            Integer relativeRowIndex,
            Boolean isHead) {

        Workbook workbook = writeSheetHolder.getSheet().getWorkbook();
        CellStyle cellStyle = workbook.createCellStyle();
        writeSheetHolder.getSheet().setColumnWidth(cell.getColumnIndex(), 7120);
        // 设置水平和垂直居中对齐
        cellStyle.setAlignment(HorizontalAlignment.CENTER);
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);
        // 设置不同行的样式
        if (isHead) {
            if (relativeRowIndex == 0 || relativeRowIndex == 1) {
                // 头的策略
                WriteCellStyle headWriteCellStyle = new WriteCellStyle();
                // 背景设置为红色
                headWriteCellStyle.setFillForegroundColor(IndexedColors.TURQUOISE.getIndex());
                WriteFont headWriteFont = new WriteFont();
                headWriteFont.setFontHeightInPoints((short) 20);
                headWriteCellStyle.setWriteFont(headWriteFont);
                WriteCellStyle.merge(headWriteCellStyle, cellDataList.get(0).getOrCreateStyle());
            } else if (relativeRowIndex == 2 || relativeRowIndex == 3) {
                // 头的策略
                WriteCellStyle headWriteCellStyle = new WriteCellStyle();
                // 背景设置为红色
                headWriteCellStyle.setFillForegroundColor(IndexedColors.LIGHT_YELLOW.getIndex());
                WriteFont headWriteFont = new WriteFont();
                headWriteFont.setFontHeightInPoints((short) 20);
                headWriteCellStyle.setWriteFont(headWriteFont);
                WriteCellStyle.merge(headWriteCellStyle, cellDataList.get(0).getOrCreateStyle());
            }
        } else {
            
        }
        cell.setCellStyle(cellStyle);
    }
}

